Index: trunk/Cocoa/Pester/Source/PSAlarmNotifierController.h
===================================================================
--- trunk/Cocoa/Pester/Source/PSAlarmNotifierController.h	(revision 100)
+++ trunk/Cocoa/Pester/Source/PSAlarmNotifierController.h	(revision 102)
@@ -23,10 +23,17 @@
     PSAlarm *alarm;
     BOOL canSnooze;
+    NSTimeInterval snoozeInterval;
 }
 
 - (id)initWithAlarm:(PSAlarm *)anAlarm;
 
+- (NSTimeInterval)snoozeInterval;
+- (BOOL)setSnoozeInterval:(NSTimeInterval)interval;
+- (void)snoozeUntilDate:(NSCalendarDate *)date;
+
+- (IBAction)snoozeIntervalUnitsChanged:(NSPopUpButton *)sender;
 - (IBAction)close:(id)sender;
 - (IBAction)snooze:(NSButton *)sender;
+- (IBAction)snoozeUntil:(NSMenuItem *)sender;
 - (IBAction)stopRepeating:(NSButton *)sender;
 
Index: trunk/Cocoa/Pester/Source/PSAlarmNotifierController.m
===================================================================
--- trunk/Cocoa/Pester/Source/PSAlarmNotifierController.m	(revision 100)
+++ trunk/Cocoa/Pester/Source/PSAlarmNotifierController.m	(revision 102)
@@ -11,4 +11,5 @@
 #import "PSAlarm.h"
 #import "PSNotifierAlert.h"
+#import "PSSnoozeUntilController.h"
 #import "NJRIntervalField.h"
 
@@ -24,5 +25,5 @@
 @implementation PSAlarmNotifierController
 
-// XXX should use NSNonactivatingPanelMask on 10.2
+// XXX should use NSNonactivatingPanelMask on 10.2?
 
 - (id)initWithAlarm:(PSAlarm *)anAlarm;
@@ -34,7 +35,7 @@
         [messageField setStringValue: [alarm message]];
         [dateField setStringValue: [alarm dateTimeString]];
-        if (![snoozeIntervalField setInterval: [alarm snoozeInterval]] &&
-            ![snoozeIntervalField setInterval: [[[NSUserDefaults standardUserDefaults] objectForKey: PSAlarmSnoozeInterval] doubleValue]])
-            [snoozeIntervalField setInterval: 15 * 60]; // 15 minutes
+        if (![self setSnoozeInterval: [alarm snoozeInterval]] &&
+            ![self setSnoozeInterval: [[[NSUserDefaults standardUserDefaults] objectForKey: PSAlarmSnoozeInterval] doubleValue]])
+            [self setSnoozeInterval: 15 * 60]; // 15 minutes
         if ([alarm isRepeating]) {
             [intervalField setStringValue:
@@ -75,5 +76,6 @@
 - (void)update:(id)sender;
 {
-    canSnooze = [snoozeIntervalField interval] != 0;
+    snoozeInterval = [snoozeIntervalField interval];
+    canSnooze = (snoozeInterval > 0);
     if (canSnooze) [nextDateField setStringValue: @"after snooze"];
     [snoozeButton setEnabled: canSnooze];
@@ -89,10 +91,37 @@
 }
 
+- (IBAction)snoozeUntil:(NSMenuItem *)sender;
+{
+    [PSSnoozeUntilController snoozeUntilControllerWithNotifierController: self];
+}
+
+- (IBAction)snoozeIntervalUnitsChanged:(NSPopUpButton *)sender;
+{
+    if ([[sender selectedItem] tag] > 0) [self update: nil];
+}
+
+- (NSTimeInterval)snoozeInterval;
+{
+    return snoozeInterval;
+}
+
+- (BOOL)setSnoozeInterval:(NSTimeInterval)interval;
+{
+    snoozeInterval = interval;
+    return [snoozeIntervalField setInterval: interval];
+}
+
 - (IBAction)snooze:(NSButton *)sender;
 {
-    NSTimeInterval snoozeInterval = [snoozeIntervalField interval];
+    snoozeInterval = [snoozeIntervalField interval];
     [alarm setSnoozeInterval: snoozeInterval];
     [[NSUserDefaults standardUserDefaults] setObject: [NSNumber numberWithDouble: snoozeInterval] forKey: PSAlarmSnoozeInterval];
     [self close: sender];
+}
+
+- (void)snoozeUntilDate:(NSCalendarDate *)date;
+{
+    [alarm setSnoozeInterval: [date timeIntervalSinceNow]];
+    [self close: self];
 }
 
Index: trunk/Cocoa/Pester/Source/PSAlarmSetController.h
===================================================================
--- trunk/Cocoa/Pester/Source/PSAlarmSetController.h	(revision 100)
+++ trunk/Cocoa/Pester/Source/PSAlarmSetController.h	(revision 102)
@@ -15,5 +15,5 @@
 @class NJRVoicePopUpButton;
 
-@interface PSAlarmSetController : NSWindowController {
+@interface PSAlarmSetController : NSWindowController <NSUserInterfaceValidations> {
     IBOutlet NSTextField *messageField;
     IBOutlet NSMatrix *inAtMatrix;
@@ -24,4 +24,5 @@
     IBOutlet NSTextField *timeDate;
     IBOutlet NSPopUpButton *timeDateCompletions; // XXX should go away when bug preventing both formatters and popup menus from existing is fixed
+    IBOutlet NSButton *timeCalendarButton;
     IBOutlet NSButtonCell *editAlert;
     IBOutlet NSTextField *alertView;
@@ -51,5 +52,7 @@
 - (IBAction)update:(id)sender;
 - (IBAction)dateCompleted:(NSPopUpButton *)sender;
+- (IBAction)showCalendar:(NSButton *)sender;
 - (IBAction)inAtChanged:(id)sender;
+- (IBAction)toggleAlertEditor:(id)sender;
 - (IBAction)editAlertChanged:(id)sender;
 - (IBAction)playSoundChanged:(id)sender;
Index: trunk/Cocoa/Pester/Source/PSAlarmSetController.m
===================================================================
--- trunk/Cocoa/Pester/Source/PSAlarmSetController.m	(revision 100)
+++ trunk/Cocoa/Pester/Source/PSAlarmSetController.m	(revision 102)
@@ -9,5 +9,7 @@
 #import "PSAlarmSetController.h"
 #import "PSAlarmAlertController.h"
+#import "PSCalendarController.h"
 #import "PSPowerManager.h"
+#import "PSTimeDateEditor.h"
 #import "NJRDateFormatter.h"
 #import "NJRFSObjectSelector.h"
@@ -71,31 +73,5 @@
     alarm = [[PSAlarm alloc] init];
     [[self window] center];
-    // XXX excessive retention of formatters?  check later...
-    [timeOfDay setFormatter: [[NJRDateFormatter alloc] initWithDateFormat: [NJRDateFormatter localizedTimeFormatIncludingSeconds: NO] allowNaturalLanguage: YES]];
-    [timeDate setFormatter: [[NJRDateFormatter alloc] initWithDateFormat: [NJRDateFormatter localizedDateFormatIncludingWeekday: NO] allowNaturalLanguage: YES]];
-    {
-        NSArray *dayNames = [defaults arrayForKey:
-            NSWeekDayNameArray];
-        NSArray *completions = [timeDateCompletions itemTitles];
-        NSEnumerator *e = [completions objectEnumerator];
-        NSString *title;
-        int itemIndex = 0;
-        NSRange matchingRange;
-        while ( (title = [e nextObject]) != nil) {
-            matchingRange = [title rangeOfString: @"ÇdayÈ"];
-            if (matchingRange.location != NSNotFound) {
-                NSMutableString *format = [title mutableCopy];
-                NSEnumerator *we = [dayNames objectEnumerator];
-                NSString *dayName;
-                [format deleteCharactersInRange: matchingRange];
-                [format insertString: @"%@" atIndex: matchingRange.location];
-                [timeDateCompletions removeItemAtIndex: itemIndex];
-                while ( (dayName = [we nextObject]) != nil) {
-                    [timeDateCompletions insertItemWithTitle: [NSString stringWithFormat: format, dayName] atIndex: itemIndex];
-                    itemIndex++;
-                }
-            } else itemIndex++;
-        }
-    }
+    [PSTimeDateEditor setUpTimeField: timeOfDay dateField: timeDate completions: timeDateCompletions];
     [editAlert setIntValue: [defaults boolForKey: PSAlertsEditing]];
     {
@@ -114,5 +90,4 @@
         [self _readAlerts: alerts];
     }
-    [timeDate setObjectValue: [NSDate date]];
     [self inAtChanged: nil]; // by convention, if sender is nil, we're initializing
     [self playSoundChanged: nil];
@@ -175,6 +150,4 @@
 }
 
-// XXX use OACalendar in popup like Palm Desktop?
-
 - (IBAction)updateDateDisplay:(id)sender;
 {
@@ -226,6 +199,10 @@
     [timeDate setEnabled: !isInterval];
     [timeDateCompletions setEnabled: !isInterval];
+    [timeCalendarButton setEnabled: !isInterval];
     if (sender != nil)
         [[self window] makeFirstResponder: isInterval ? (NSTextField *)timeInterval : timeOfDay];
+    if (!isInterval) { // need to do this every time the controls are enabled
+        [timeOfDay setNextKeyView: timeDate];
+    }
     // NSLog(@"UPDATING FROM inAtChanged");
     [self update: nil];
@@ -238,5 +215,28 @@
 }
 
+#pragma mark calendar
+
+- (IBAction)showCalendar:(NSButton *)sender;
+{
+    [PSCalendarController controllerWithDate: [NSCalendarDate dateForDay: [timeDate objectValue]] delegate: self];
+}
+
+- (void)calendarController:(PSCalendarController *)calendar didSetDate:(NSCalendarDate *)date;
+{
+    [timeDate setObjectValue: date];
+    [self update: self];
+}
+
+- (NSView *)calendarControllerLaunchingView:(PSCalendarController *)controller;
+{
+    return timeCalendarButton;
+}
+
 #pragma mark alert editing
+
+- (IBAction)toggleAlertEditor:(id)sender;
+{
+    [editAlert performClick: self];
+}
 
 - (IBAction)editAlertChanged:(id)sender;
@@ -293,5 +293,4 @@
 }
 
-
 - (IBAction)playSoundChanged:(id)sender;
 {
@@ -459,5 +458,5 @@
     [alarm setMessage: [messageField stringValue]];
     if (![alarm setTimer]) {
-        [self setStatus: [@"Unable to set alarm.  " stringByAppendingString: [alarm invalidMessage]]];
+        [self setStatus: [@"Unable to set alarm. " stringByAppendingString: [alarm invalidMessage]]];
         return;
     }
@@ -475,4 +474,14 @@
 }
 
+- (BOOL)validateUserInterfaceItem:(id <NSValidatedUserInterfaceItem>)anItem;
+{
+    if ([anItem action] == @selector(toggleAlertEditor:)) {
+        if ([NSApp keyWindow] != [self window])
+            return NO;
+        [(NSMenuItem *)anItem setState: [editAlert intValue] ? NSOnState : NSOffState];
+    }
+    return YES;
+}
+
 @end
 
Index: trunk/Cocoa/Pester/Source/PSAlarmsController.h
===================================================================
--- trunk/Cocoa/Pester/Source/PSAlarmsController.h	(revision 100)
+++ trunk/Cocoa/Pester/Source/PSAlarmsController.h	(revision 102)
@@ -11,8 +11,9 @@
 
 @interface PSAlarmsController : NSWindowController {
-    IBOutlet NSTableView *tableView;
+    IBOutlet NSTableView *alarmList;
     IBOutlet NSButton *removeButton;
     PSAlarms *alarms;
     NSArray *reorderedAlarms;
+    NSDictionary *messageAttributes;
 }
 
Index: trunk/Cocoa/Pester/Source/PSAlarmsController.m
===================================================================
--- trunk/Cocoa/Pester/Source/PSAlarmsController.m	(revision 100)
+++ trunk/Cocoa/Pester/Source/PSAlarmsController.m	(revision 102)
@@ -10,4 +10,5 @@
 #import "PSAlarm.h"
 #import "PSAlerts.h"
+#import "NSString-NJRExtensions.h"
 #import "NSTableView-NJRExtensions.h"
 #import "NJRTableView.h"
@@ -18,5 +19,5 @@
 - (void)alarmsChanged;
 {
-    reorderedAlarms = [[tableView delegate] reorderedDataForData: [alarms alarms]];
+    reorderedAlarms = [[alarmList delegate] reorderedDataForData: [alarms alarms]];
 }
 
@@ -34,18 +35,25 @@
            }
         [[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(alarmsChanged) name: PSAlarmsDidChangeNotification object: alarms];
-        [[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(tableViewSelectionDidChange:) name: NSTableViewSelectionDidChangeNotification object: tableView];
-        [tableView setAutosaveName: @"Alarm list"];
-        [tableView setAutosaveTableColumns: YES];
+        [[NSNotificationCenter defaultCenter] addObserver: self selector: @selector(tableViewSelectionDidChange:) name: NSTableViewSelectionDidChangeNotification object: alarmList];
+        messageAttributes = [[NSDictionary alloc] initWithObjectsAndKeys: [[[alarmList tableColumnWithIdentifier: @"message"] dataCell] font], NSFontAttributeName, nil];
+        [alarmList setAutosaveName: @"Alarm list"];
+        [alarmList setAutosaveTableColumns: YES];
         [self alarmsChanged];
-        [[self window] makeFirstResponder: tableView];
-        [[self window] setResizeIncrements: NSMakeSize(1, [tableView cellHeight])];
+        [[self window] makeFirstResponder: alarmList];
+        [[self window] setResizeIncrements: NSMakeSize(1, [alarmList cellHeight])];
     }
     return self;
 }
 
+- (void)dealloc;
+{
+    [reorderedAlarms release];
+    [messageAttributes release];
+    [super dealloc];
+}
 
 - (IBAction)remove:(id)sender;
 {
-    [alarms removeAlarms: [[tableView delegate] selectedItems]];
+    [alarms removeAlarms: [[alarmList delegate] selectedItems]];
 }
 
@@ -63,6 +71,9 @@
     PSAlarm *alarm = [reorderedAlarms objectAtIndex: row];
 
-    if ([[tableColumn identifier] isEqualToString: @"message"]) return [alarm message];
-    else {
+    if ([[tableColumn identifier] isEqualToString: @"message"]) {
+        NSMutableString *message = [[alarm message] mutableCopy];
+        [message truncateToWidth: [tableView frameOfCellAtColumn: 0 row: row].size.width by: NSLineBreakByTruncatingTail withAttributes: messageAttributes];
+        return [message autorelease];
+    } else {
         NSCalendarDate *date = [alarm date];
         if ([[tableColumn identifier] isEqualToString: @"date"]) return [alarm shortDateString];
@@ -96,5 +107,5 @@
 - (void)tableViewSelectionDidChange:(NSNotification *)aNotification;
 {
-    [removeButton setEnabled: ([tableView numberOfSelectedRows] != 0)];
+    [removeButton setEnabled: ([alarmList numberOfSelectedRows] != 0)];
 }
 
@@ -115,7 +126,7 @@
 - (NSRect)windowWillUseStandardFrame:(NSWindow *)sender defaultFrame:(NSRect)defaultFrame;
 {
-    NSWindow *window = [tableView window];
+    NSWindow *window = [alarmList window];
     NSRect frame = [window frame];
-    NSScrollView *scrollView = [tableView enclosingScrollView];
+    NSScrollView *scrollView = [alarmList enclosingScrollView];
     float displayedHeight = [[scrollView contentView] bounds].size.height;
     float heightChange = [[scrollView documentView] bounds].size.height - displayedHeight;
@@ -124,6 +135,6 @@
     if (heightChange >= 0 && heightChange <= 1) {
         // either the window is already optimal size, or it's too big
-        float rowHeight = [tableView cellHeight];
-        heightChange = (rowHeight * [tableView numberOfRows]) - displayedHeight;
+        float rowHeight = [alarmList cellHeight];
+        heightChange = (rowHeight * [alarmList numberOfRows]) - displayedHeight;
     }
 
Index: trunk/Cocoa/Pester/Source/PSApplication.m
===================================================================
--- trunk/Cocoa/Pester/Source/PSApplication.m	(revision 100)
+++ trunk/Cocoa/Pester/Source/PSApplication.m	(revision 102)
@@ -11,4 +11,5 @@
 #import "PSAlarmAlertController.h"
 #import "PSAlarmsController.h"
+#import "NJRReadMeController.h"
 #import "PSAlarm.h"
 #import "PSAlarms.h"
@@ -30,5 +31,5 @@
 - (IBAction)showHelp:(id)sender;
 {
-    [[NSWorkspace sharedWorkspace] openFile: [[NSBundle mainBundle] pathForResource: @"Read Me" ofType: @"rtfd"]];
+    [NJRReadMeController readMeControllerWithRTFDocument: [[NSBundle mainBundle] pathForResource: @"Read Me" ofType: @"rtfd"]];
 }
 
@@ -154,5 +155,7 @@
 - (BOOL)applicationShouldHandleReopen:(NSApplication *)sender hasVisibleWindows:(BOOL)flag;
 {
-    if (!flag && ![[PSAlarms allAlarms] alarmsExpiring]) [alarmSetController showWindow: self];
+    // XXX sometimes alarmsExpiring is NO (?), and we display the alarm set controller on top of an expiring alarm, try to reproduce
+    if (!flag && ![[PSAlarms allAlarms] alarmsExpiring] && [NSApp modalWindow] == nil)
+        [alarmSetController showWindow: self];
     return YES;
 }
@@ -215,3 +218,16 @@
 }
 
+// calendar window (running in modal session) will appear even when app is in background; shouldn't
+- (void)applicationWillBecomeActive:(NSNotification *)notification;
+{
+    NSWindow *modalWindow = [NSApp modalWindow];
+    if (modalWindow != nil) [modalWindow makeKeyAndOrderFront: nil];
+}
+
+- (void)applicationWillResignActive:(NSNotification *)notification;
+{
+    NSWindow *modalWindow = [NSApp modalWindow];
+    if (modalWindow != nil) [modalWindow orderOut: nil];
+}
+
 @end
Index: trunk/Cocoa/Pester/Source/PSCalendarController.h
===================================================================
--- trunk/Cocoa/Pester/Source/PSCalendarController.h	(revision 102)
+++ trunk/Cocoa/Pester/Source/PSCalendarController.h	(revision 102)
@@ -0,0 +1,34 @@
+//
+//  PSCalendarController.h
+//  Pester
+//
+//  Created by Nicholas Riley on Fri Feb 14 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import <AppKit/AppKit.h>
+
+@class OACalendarView;
+
+@interface PSCalendarController : NSWindowController {
+    IBOutlet OACalendarView *calendarView;
+    IBOutlet NSButton *okButton;
+    id delegate;
+}
+
++ (PSCalendarController *)controllerWithDate:(NSCalendarDate *)aDate delegate:(id)aDelegate;
+
+- (id)initWithDate:(NSCalendarDate *)aDate delegate:(id)aDelegate;
+
+- (IBAction)close:(NSButton *)sender;
+- (IBAction)cancel:(NSButton *)sender;
+- (IBAction)today:(NSButton *)sender;
+
+@end
+
+@interface NSObject (PSCalendarControllerDelegate)
+
+- (void)calendarController:(PSCalendarController *)controller didSetDate:(NSCalendarDate *)date;
+- (NSView *)calendarControllerLaunchingView:(PSCalendarController *)controller;
+
+@end
Index: trunk/Cocoa/Pester/Source/PSCalendarController.m
===================================================================
--- trunk/Cocoa/Pester/Source/PSCalendarController.m	(revision 102)
+++ trunk/Cocoa/Pester/Source/PSCalendarController.m	(revision 102)
@@ -0,0 +1,114 @@
+//
+//  PSCalendarController.m
+//  Pester
+//
+//  Created by Nicholas Riley on Fri Feb 14 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import "PSCalendarController.h"
+#import "OACalendarView.h"
+#import "NSCalendarDate-OFExtensions.h"
+#import "NSCalendarDate-NJRExtensions.h"
+
+@implementation PSCalendarController
+
++ (PSCalendarController *)controllerWithDate:(NSCalendarDate *)aDate delegate:(id)aDelegate;
+{
+    return [[self alloc] initWithDate:(NSCalendarDate *)aDate delegate:(id)aDelegate];
+}
+
+- (id)initWithDate:(NSCalendarDate *)aDate delegate:(id)aDelegate;
+{
+    if ([self initWithWindowNibName: @"Calendar"]) {
+        NSWindow *window = [self window]; // connect outlets
+        [calendarView setTarget: self]; // delegate
+        [calendarView setSelectionType: OACalendarViewSelectByDay];
+        [calendarView setShowsDaysForOtherMonths: YES];
+        if (aDate == nil) aDate = [NSCalendarDate calendarDate];
+        [calendarView setSelectedDay: aDate];
+        [calendarView setVisibleMonth: aDate];
+        delegate = [aDelegate retain];
+
+        NSView *view = [aDelegate calendarControllerLaunchingView: self];
+        if (view != nil) {
+            NSRect rect = [view convertRect: [view bounds] toView: nil];
+            NSWindow *parentWindow = [view window];
+            rect.origin = [parentWindow convertBaseToScreen: rect.origin];
+            rect.origin.x -= [window frame].size.width - rect.size.width;
+            [window setFrameTopLeftPoint: rect.origin];
+            NSRect visibleFrame = [[parentWindow screen] visibleFrame];
+            if (!NSContainsRect(visibleFrame, [window frame])) {
+                NSPoint textFieldTopLeft = { rect.origin.x, rect.origin.y + rect.size.height };
+                [window setFrameOrigin: textFieldTopLeft];
+            }
+        }
+        [window setOpaque: NO];
+        [window setBackgroundColor: [NSColor colorWithCalibratedWhite: 0.81f alpha: 0.9f]];
+        [window setHasShadow: NO];
+        [window setLevel: NSModalPanelWindowLevel];
+        [NSApp runModalForWindow: window];
+    }
+    return self;
+}
+
+- (void)dealloc;
+{
+    [delegate release];
+    [super dealloc];
+}
+
+- (IBAction)close:(NSButton *)sender;
+{
+    [NSApp stopModal];
+    [delegate calendarController: self didSetDate: [calendarView selectedDay]];
+    [self close];
+}
+
+- (IBAction)cancel:(NSButton *)sender;
+{
+    [NSApp stopModal];
+    [self close];
+}
+
+- (IBAction)today:(NSButton *)sender;
+{
+    NSCalendarDate *today = [NSCalendarDate calendarDate];
+    [calendarView setSelectedDay: today];
+    [calendarView setVisibleMonth: today];
+}
+
+@end
+
+@implementation PSCalendarController (OACalendarViewDelegate)
+
+- (BOOL)calendarView:(OACalendarView *)aCalendarView shouldSelectDate:(NSCalendarDate *)aDate;
+{
+    return ([[NSCalendarDate dateForDay: aDate] compare: [NSCalendarDate dateForDay: [NSCalendarDate calendarDate]]] != NSOrderedAscending);
+}
+
+- (int)calendarView:(OACalendarView *)aCalendarView highlightMaskForVisibleMonth:(NSCalendarDate *)visibleMonth;
+{
+    NSCalendarDate *today = [NSCalendarDate calendarDate];
+    if ([visibleMonth yearOfCommonEra] == [today yearOfCommonEra] && [visibleMonth monthOfYear] == [today monthOfYear]) {
+        return 1 << ([today dayOfMonth] - 1 + [[today firstDayOfMonth] dayOfWeek]);
+    }
+
+    return 0;
+}
+
+- (void)calendarViewShouldDismiss:(OACalendarView *)aCalendarView;
+{
+    [okButton performClick: aCalendarView];
+}
+
+@end
+
+@implementation PSCalendarController (NSWindowNotifications)
+
+- (void)windowWillClose:(NSNotification *)notification;
+{
+    [self autorelease];
+}
+
+@end
Index: trunk/Cocoa/Pester/Source/PSSnoozeUntilController.h
===================================================================
--- trunk/Cocoa/Pester/Source/PSSnoozeUntilController.h	(revision 102)
+++ trunk/Cocoa/Pester/Source/PSSnoozeUntilController.h	(revision 102)
@@ -0,0 +1,34 @@
+//
+//  PSSnoozeUntilController.h
+//  Pester
+//
+//  Created by Nicholas Riley on Sun Feb 16 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import <AppKit/AppKit.h>
+#import "PSAlarm.h"
+
+@class PSAlarmNotifierController;
+
+@interface PSSnoozeUntilController : NSWindowController {
+    IBOutlet NSTextField *messageField;
+    IBOutlet NSTextField *timeOfDay;
+    IBOutlet NSTextField *timeDate;
+    IBOutlet NSPopUpButton *timeDateCompletions; // XXX should go away when bug preventing both formatters and popup menus from existing is fixed
+    IBOutlet NSButton *timeCalendarButton;
+    IBOutlet NSButton *snoozeButton;
+    NSTimeInterval snoozeInterval;
+    PSAlarm *alarm; // not a real alarm, used for date<->interval conversion
+}
+
++ (PSSnoozeUntilController *)snoozeUntilControllerWithNotifierController:(PSAlarmNotifierController *)aController;
+- (id)initWithNotifierController:(PSAlarmNotifierController *)aController;
+
+- (IBAction)update:(id)sender;
+- (IBAction)dateCompleted:(NSPopUpButton *)sender;
+- (IBAction)showCalendar:(NSButton *)sender;
+- (IBAction)close:(id)sender;
+- (IBAction)snooze:(NSButton *)sender;
+
+@end
Index: trunk/Cocoa/Pester/Source/PSSnoozeUntilController.m
===================================================================
--- trunk/Cocoa/Pester/Source/PSSnoozeUntilController.m	(revision 102)
+++ trunk/Cocoa/Pester/Source/PSSnoozeUntilController.m	(revision 102)
@@ -0,0 +1,162 @@
+//
+//  PSSnoozeUntilController.m
+//  Pester
+//
+//  Created by Nicholas Riley on Sun Feb 16 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import "PSAlarmNotifierController.h"
+#import "PSCalendarController.h"
+#import "PSSnoozeUntilController.h"
+#import "PSTimeDateEditor.h"
+#import "NSCalendarDate-NJRExtensions.h"
+
+@implementation PSSnoozeUntilController
+
++ (PSSnoozeUntilController *)snoozeUntilControllerWithNotifierController:(PSAlarmNotifierController *)aController;
+{
+    return [[self alloc] initWithNotifierController: aController];
+}
+
+- (id)initWithNotifierController:(PSAlarmNotifierController *)aController;
+{
+    if ([self initWithWindowNibName: @"Snooze until"]) {
+        NSWindow *window = [self window];
+        alarm = [[PSAlarm alloc] init];
+        snoozeInterval = [aController snoozeInterval];
+        [alarm setInterval: snoozeInterval];
+        [PSTimeDateEditor setUpTimeField: timeOfDay dateField: timeDate completions: timeDateCompletions];
+        if ([alarm isValid]) {
+            [timeOfDay setObjectValue: [alarm time]];
+            [timeDate setObjectValue: [alarm date]];
+        }
+        [self update: self];
+        
+        [NSApp beginSheet: window modalForWindow: [aController window] modalDelegate: self didEndSelector: @selector(sheetDidEnd:returnCode:contextInfo:) contextInfo: aController];
+
+        // work around Cocoa confusion with our bizarre key loop
+        [timeOfDay setNextKeyView: timeDate];
+    }
+    return self;
+}
+
+- (void)dealloc;
+{
+    [alarm release];
+    [super dealloc];
+}
+
+- (void)sheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(PSAlarmNotifierController *)aController;
+{
+    if (returnCode == NSRunAbortedResponse) {
+        [aController setSnoozeInterval: snoozeInterval];
+        [sheet close];
+    } else {
+        [aController snoozeUntilDate: [alarm date]];
+    }
+    // XXX according to Cocoa documentation, the sheet should hide after the didEnd method returns, but it doesn't.
+}
+
+// XXX yuck, should not be duplicating this method between PSAlarmSetController and PSSnoozeUntilController
+// XXX with -[NSControl currentEditor] don't need to compare?  Also check -[NSControl validateEditing]
+- (id)objectValueForTextField:(NSTextField *)field whileEditing:(id)sender;
+{
+    if (sender == field) {
+        NSString *stringValue = [[[self window] fieldEditor: NO forObject: field] string];
+        id obj = nil;
+        [[field formatter] getObjectValue: &obj forString: stringValue errorDescription: NULL];
+        // NSLog(@"from field editor: %@", obj);
+        return obj;
+    } else {
+        // NSLog(@"from field: %@", [field objectValue]);
+        return [field objectValue];
+    }
+}
+
+#pragma mark date setting
+
+- (void)setAlarmDateAndInterval:(id)sender;
+{
+    [alarm setForDate: [self objectValueForTextField: timeDate whileEditing: sender]
+               atTime: [self objectValueForTextField: timeOfDay whileEditing: sender]];
+}
+
+// Be careful not to hook up any of the text fields' actions to update: because we handle them in controlTextDidChange: instead.  If we could get the active text field somehow via public API (guess we could use controlTextDidBegin/controlTextDidEndEditing) then we'd not need to overload the update sender for this purpose.  Or, I guess, we could use another method other than update.  It should not be this hard to implement what is essentially standard behavior.  Sigh.
+// Note: finding out whether a given control is editing is easier.  See: <http://cocoa.mamasam.com/COCOADEV/2002/03/2/28501.php>.
+
+- (IBAction)update:(id)sender;
+{
+    BOOL isValid;
+    [self setAlarmDateAndInterval: sender];
+    isValid = [alarm isValid];
+    [snoozeButton setEnabled: isValid];
+    if (!isValid) {
+        [messageField setStringValue: [alarm invalidMessage]];
+    } else {
+        [messageField setStringValue: @""];
+    }
+}
+
+- (IBAction)dateCompleted:(NSPopUpButton *)sender;
+{
+    [timeDate setStringValue: [sender titleOfSelectedItem]];
+    [self update: sender];
+}
+
+#pragma mark calendar
+
+- (IBAction)showCalendar:(NSButton *)sender;
+{
+    [PSCalendarController controllerWithDate: [NSCalendarDate dateForDay: [timeDate objectValue]] delegate: self];
+}
+
+- (void)calendarController:(PSCalendarController *)calendar didSetDate:(NSCalendarDate *)date;
+{
+    [timeDate setObjectValue: date];
+    [self update: self];
+}
+
+- (NSView *)calendarControllerLaunchingView:(PSCalendarController *)controller;
+{
+    return timeCalendarButton;
+}
+
+#pragma mark actions
+
+- (IBAction)close:(id)sender;
+{
+    [NSApp endSheet: [self window] returnCode: NSRunAbortedResponse];
+}
+
+- (IBAction)snooze:(NSButton *)sender;
+{
+    if ([alarm isValid]) {
+        [NSApp endSheet: [self window] returnCode: NSRunStoppedResponse];
+    } else {
+        [messageField setStringValue: [@"Unable to snooze. " stringByAppendingString: [alarm invalidMessage]]];
+        [sender setEnabled: NO];
+    }
+}
+
+@end
+
+@implementation PSSnoozeUntilController (NSControlSubclassNotifications)
+
+// called because we're the delegate
+
+- (void)controlTextDidChange:(NSNotification *)notification;
+{
+    [self update: [notification object]];
+}
+
+@end
+
+@implementation PSSnoozeUntilController (NSWindowNotifications)
+
+- (void)windowWillClose:(NSNotification *)notification;
+{
+    [self autorelease];
+}
+
+@end
Index: trunk/Cocoa/Pester/Source/PSSpeechAlert.m
===================================================================
--- trunk/Cocoa/Pester/Source/PSSpeechAlert.m	(revision 100)
+++ trunk/Cocoa/Pester/Source/PSSpeechAlert.m	(revision 102)
@@ -55,5 +55,8 @@
     alarm = anAlarm;
     [speaker setDelegate: self];
-    [speaker setVoice: [[SUSpeaker voiceNames] indexOfObject: voice] + 1];
+    unsigned voiceIndex = [[SUSpeaker voiceNames] indexOfObject: voice];
+    if (voiceIndex == NSNotFound)
+        voiceIndex = [[SUSpeaker voiceNames] indexOfObject: [SUSpeaker defaultVoice]];
+    [speaker setVoice: voiceIndex + 1];
     [speaker speakText: [alarm message]];
 }
@@ -78,5 +81,5 @@
 {
     if ( (self = [self init]) != nil) {
-        voice = [dict objectForRequiredKey: PLAlertVoice];
+        voice = [[dict objectForRequiredKey: PLAlertVoice] retain];
     }
     return self;
Index: trunk/Cocoa/Pester/Source/PSTimeDateEditor.h
===================================================================
--- trunk/Cocoa/Pester/Source/PSTimeDateEditor.h	(revision 102)
+++ trunk/Cocoa/Pester/Source/PSTimeDateEditor.h	(revision 102)
@@ -0,0 +1,18 @@
+//
+//  PSDateCompletions.h
+//  Pester
+//
+//  Created by Nicholas Riley on Sun Feb 16 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import <AppKit/AppKit.h>
+
+
+@interface PSTimeDateEditor : NSObject {
+
+}
+
++ (void)setUpTimeField:(NSTextField *)timeOfDay dateField:(NSTextField *)timeDate completions:(NSPopUpButton *)timeDateCompletions;
+
+@end
Index: trunk/Cocoa/Pester/Source/PSTimeDateEditor.m
===================================================================
--- trunk/Cocoa/Pester/Source/PSTimeDateEditor.m	(revision 102)
+++ trunk/Cocoa/Pester/Source/PSTimeDateEditor.m	(revision 102)
@@ -0,0 +1,50 @@
+//
+//  PSTimeDateEditor.m
+//  Pester
+//
+//  Created by Nicholas Riley on Sun Feb 16 2003.
+//  Copyright (c) 2003 Nicholas Riley. All rights reserved.
+//
+
+#import "PSTimeDateEditor.h"
+#import "NJRDateFormatter.h"
+
+@implementation PSTimeDateEditor
+
++ (void)setUpTimeField:(NSTextField *)timeOfDay dateField:(NSTextField *)timeDate completions:(NSPopUpButton *)timeDateCompletions;
+{
+    static NJRDateFormatter *timeFormatter = nil, *dateFormatter = nil;
+    if (timeFormatter == nil) {
+        timeFormatter = [[NJRDateFormatter alloc] initWithDateFormat: [NJRDateFormatter localizedTimeFormatIncludingSeconds: NO] allowNaturalLanguage: YES];
+        dateFormatter = [[NJRDateFormatter alloc] initWithDateFormat: [NJRDateFormatter localizedDateFormatIncludingWeekday: NO] allowNaturalLanguage: YES];
+    }
+    [timeOfDay setFormatter: timeFormatter];
+    [timeDate setFormatter: dateFormatter];
+    [timeDate setObjectValue: [NSDate date]];
+
+    // add completions
+    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
+    NSArray *dayNames = [defaults arrayForKey: NSWeekDayNameArray];
+    NSArray *completions = [timeDateCompletions itemTitles];
+    NSEnumerator *e = [completions objectEnumerator];
+    NSString *title;
+    int itemIndex = 0;
+    NSRange matchingRange;
+    while ( (title = [e nextObject]) != nil) {
+        matchingRange = [title rangeOfString: @"ÇdayÈ"];
+        if (matchingRange.location != NSNotFound) {
+            NSMutableString *format = [title mutableCopy];
+            NSEnumerator *we = [dayNames objectEnumerator];
+            NSString *dayName;
+            [format deleteCharactersInRange: matchingRange];
+            [format insertString: @"%@" atIndex: matchingRange.location];
+            [timeDateCompletions removeItemAtIndex: itemIndex];
+            while ( (dayName = [we nextObject]) != nil) {
+                [timeDateCompletions insertItemWithTitle: [NSString stringWithFormat: format, dayName] atIndex: itemIndex];
+                itemIndex++;
+            }
+        } else itemIndex++;
+    }
+}
+
+@end
